<?xml version='1.0' standalone='no'?>
<!DOCTYPE xsl:stylesheet [ <!ENTITY nbsp '&#160;'> ]>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:gjs="http://www.georgejames.com">

	<xsl:include href='gjsForm.xsl'/>

	<xsl:template match="Form">
	  <gjs:form
	   title='Calendar control - test02'
	   save='{/Form/@save}'
	   close='{/Form/@close}'
	   delete='{/Form/@delete}'
	   print='{/Form/@print}'
	   help='{/Form/@help}'
	   ok='{/Form/@ok}'
	   cancel='{/Form/@cancel}'
	   locale='{/Form/user/@locale}'>
     
     <script language='javascript'>
function fnItemSaveClose() {
  var ans=''
  ans=ans+getAttr(document.getElementById('test0201'),'gjsInternalValue')+"\n"
  ans=ans+getAttr(document.getElementById('test0202'),'gjsInternalValue')+"\n"
  ans=ans+getAttr(document.getElementById('test0203'),'gjsInternalValue')+"\n"
  ans=ans+getAttr(document.getElementById('test0204'),'gjsInternalValue')+"\n"
  ans=ans+getAttr(document.getElementById('test0205'),'gjsInternalValue')+"\n"
  ans=ans+getAttr(document.getElementById('test0206'),'gjsInternalValue')+"\n"
  alert(ans)
}
     </script>

	    <gjs:information>
	      This form tests the various permutations of the calendar control at level 5.
        The user's locale is <xsl:value-of select='/Form/user/@locale'/>.
	    </gjs:information>

			<gjs:frame>
				<!-- Set up frame column widths -->
				<gjs:columnWidths>
				  <gjs:column width='120'/>
				  <gjs:column width='600'/>
				</gjs:columnWidths>


				<gjs:fields>

					<gjs:calendar
					 id='test0201'
					 gjsInternalValue='19991231'>
						<label>Standard</label>	 
					 </gjs:calendar>
					 
					<gjs:calendar
					 id='test0202'
					 gjsInternalValue='{/Form/someElement/@someDate}'>
						<label>Date from xml file</label>	 
					 </gjs:calendar>

					<gjs:calendar
					 id='test0203'
					 gjsInternalValue='{/Form/someElement/@someDate}'
					 readonly='1'>
						<label>Read only</label>	 
					 </gjs:calendar>

					<gjs:calendar
					 id='test0204'
					 gjsInternalValue='{/Form/someElement/@someDate}'
					 calendar='0'>
						<label>No calendar</label>	 
					 </gjs:calendar>

					<gjs:calendar
					 id='test0205'
					 gjsInternalValue='{/Form/someElement/@someDate}'
					 validate='0'>
						<label>No validation</label>	 
					 </gjs:calendar>

					<gjs:calendar
					 id='test0206'
					 gjsInternalValue='{/Form/someElement/@someDate}'
					 gjsLocale='EUROPE'>
						<label>EUROPE locale</label>	 
					 </gjs:calendar>

			  </gjs:fields>

			</gjs:frame>
	  </gjs:form>
	</xsl:template>

</xsl:stylesheet>
