//vc/ VC/m ChangeRequestType Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    ChangeRequestType.js
//vc/ Component: T.ChangeRequestType.js


	// ChangeRequestType Class
ChangeRequestType = {}


ChangeRequestType.Current=Disabled;
ChangeRequestType.windowProperties  = 'left=100,top=100,height=550,width=475,toolbar=no';
ChangeRequestType.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of types and make this the active folder
ChangeRequestType.fnList = function() {
	//
	SelectedClass=ChangeRequestType;
	Class.fnUnselect();
	//
	ServerLink.fnDo('ChangeRequestType.fnListResult','ChangeRequestType.fnList','')
}

ChangeRequestType.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}

	// Private - Invoked when an item is selected on the list
ChangeRequestType.fnSelect = function(oCell) {
	Class.fnSelect(ChangeRequestType,oCell);
}


	// Public - Open new Change Request Type window
ChangeRequestType.fnNew = function() {
	fnRunWindow("ChangeRequestType.fnNew",ChangeRequestType.windowProperties); 
}

	// Public - Open Change Request Type
ChangeRequestType.fnOpen = function(sType) {
	//
	var url;
	//
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('ChangeRequestType.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sType) ;
	//
	// Open change request window
	winChref=window.open(url,'_blank',ChangeRequestType.windowProperties) ;
	winChref.focus();
}

	// Public - Delete a Change Request Type
ChangeRequestType.fnDelete = function(sType) {
	//
	var arguments;
	//
	if (!confirm("Are you sure you want to delete "+sType+" ?")) return;
	//
	arguments = sType;
	//
	parent.serverLink.fnDo('ChangeRequestType.fnDeleteResult','ChangeRequestType.fnDelete',arguments);
}

ChangeRequestType.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	ChangeRequestType.fnList();
}

ChangeRequestType.Item = {

	// Public - delete selected Change Request Type (if there is one)
 fnDelete: function() {
	if (typeof(ChangeRequestType.Current)=='undefined') return;
	ChangeRequestType.fnDelete(getAttr(ChangeRequestType.selectedCell,'gjsItem'));
 },

	// Public - open selected Change Request Type (if there is one)
 fnOpen: function() {
	if (typeof(ChangeRequestType.Current)=='undefined') return;
	ChangeRequestType.fnOpen(getAttr(ChangeRequestType.selectedCell,'gjsItem'));
 }
}
