//vc/ VC/m Function Class
//vc/ Copyright 1999,2002 George James
//vc/ Object:    Function.js
//vc/ Component: T.Function.js


	// Function Class
Function = {}

Function.Current=Disabled;
Function.windowProperties  = 'left=50,top=50,width=500,height=350,toolbar=no';
Function.windowProperties += ',location=no,directories=no,status=yes,resizable=yes,menubar=no';


	// Public - Display List of functions and make this the active folder
Function.fnList = function() {
	//
	SelectedClass=Function;
	Class.fnUnselect();
	//
	ServerLink.fnDo('Function.fnListResult','Function.fnList','')
}

Function.fnListResult = function(oResult) {
	//
  // Copy results from oResult to document
  ServerLink.fnUpdate(oResult,'divFolderHeadingCaption')
  ServerLink.fnUpdate(oResult,'divMainBody')
  ServerLink.fnUpdate(oResult,'divMainHead')
}


	// Private - Invoked when an item is selected on the list
Function.fnSelect = function(oCell) {
	Class.fnSelect(Function,oCell);
}


	// Public - Open new Function window
Function.fnNew = function() {
	fnRunWindow("Function.fnNew",Function.windowProperties); 
}

	// Public - Open Function
Function.fnOpen = function(sFunction) {
	;
	var url;
	;
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Function.fnOpen') ;
	url += '&selectedItem=' + encodeURIComponent(sFunction) ;
	;
	// Open window
	winChref=window.open(url,'_blank',Function.windowProperties) ;
	winChref.focus();
}

	// Public - Copy Function
Function.fnCopy = function(sFunction) {
	;
	var url;
	;
	// Build url string
	url  = parent.serverUrl ;
	url += '&page=' + escape('Function.fnCopy') ;
	url += '&selectedItem=' + encodeURIComponent(sFunction) ;
	;
	// Open window
	winChref=window.open(url,'_blank',Function.windowProperties) ;
	winChref.focus();
}


	// Public - Arguments for Refresh Function
Function.fnRefreshArguments = function(oMain)   {
  //
	var arguments=""
	//
  arguments +=          getAttr(oMain,"gjsParentId")
  arguments += '\002' + gjsTree.fnMores(fnElement(getAttr(oMain,"gjsRowId")+'click').previousElementSibling)
	arguments += '\002' + getAttr(oMain,"gjsItem")
	arguments += '\002' + getAttr(oMain,"gjsRowId")
	arguments += '\002' + getAttr(fnElement(getAttr(oMain,"gjsRowId")+'body').parentNode,"gjsReferenceHeadingId")
	//
	return arguments
}


	// Public - Refresh Function
Function.fnRefresh = function(arguments)   {
	//
	ServerLink.fnDo('Function.fnRefreshResult','Function.fnRefresh',arguments)
}


Function.fnRefreshResult = function(oResult) {
	gjsTree.fnRefreshRows("divMainBody",oResult)
	gjsTree.fnDeleteRows("divRowDelete",oResult)
}


	// Public - Delete an item
Function.fnDelete = function(sFunction) {
	;
	var arguments;
	;
	if (!confirm("Are you sure you want to delete "+sFunction+" ?")) return;
	;
	arguments = sFunction;
	;
	parent.serverLink.fnDo('Function.fnDeleteResult','Function.fnDelete',arguments);
}


Function.fnDeleteResult = function(result) {
	if (result!="OK") {
		alert(result);
		return;
	}
	Function.fnList();
}

Function.Item = {}

Function.Item.fnDelete = function() {
	if (typeof(Function.Current)=='undefined') return;
	Function.fnDelete(getAttr(Function.selectedCell,"gjsItem"));
}
	// Public - open selected item (if there is one)
Function.Item.fnOpen = function() {
	if (typeof(Function.Current)=='undefined') return;
	Function.fnOpen(getAttr(Function.selectedCell,"gjsItem"));
}
	// Public - copy selected item (if there is one)
Function.Item.fnCopy = function() {
	if (typeof(Function.Current)=='undefined') return;
	Function.fnCopy(getAttr(Function.selectedCell,"gjsItem"));
}

