<?xml version='1.0' encoding='UTF-8'?>
<xsl:stylesheet
 version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:fo="http://www.w3.org/1999/XSL/Format"
 xmlns:gjs="http://www.georgejames.com">

  
  <xsl:import href='gjsReport_Basic.xsl'/>

  <xsl:variable name="title">Function List</xsl:variable>
  
  <!-- Default output - override this example template with your own -->
  <xsl:template name="reportTable">
    <fo:table-column column-width="70mm"/>
    <fo:table-column column-width="100mm"/>
    <fo:table-column />
    <fo:table-header>
      <fo:table-row background-color="#F0F0F0">
        <fo:table-cell padding="1mm" border-width="0.1mm" border-style="solid" border-color="gray" padding-start='5mm'>
          <fo:block color="gray">Function</fo:block>
        </fo:table-cell>
        <fo:table-cell padding="1mm" border-width="0.1mm" border-style="solid" border-color="gray" padding-start='5mm'>
          <fo:block color="gray">Description</fo:block>
        </fo:table-cell>
        <fo:table-cell padding="1mm" border-width="0.1mm" border-style="solid" border-color="gray" padding-start='5mm'>
          <fo:block color="gray">Server-side method</fo:block>
        </fo:table-cell>
      </fo:table-row>
    </fo:table-header>
    <fo:table-body>

      <xsl:apply-templates />

    </fo:table-body>
  </xsl:template>


<xsl:template match='functions/function'>
  <fo:table-row>
    <fo:table-cell padding="1mm" padding-start='5mm'>
      <fo:block><xsl:value-of select='@function'/></fo:block>
    </fo:table-cell>
    <fo:table-cell padding="1mm" padding-start='5mm'>
      <fo:block><xsl:value-of select='@description'/></fo:block>
    </fo:table-cell>
    <fo:table-cell padding="1mm" padding-start='5mm'>
      <fo:block><xsl:value-of select='@serverSideMethod'/></fo:block>
    </fo:table-cell>
  </fo:table-row>
</xsl:template>

</xsl:stylesheet>
