// VC/m menu bar
// Object:     %Serenj74/js.0
// Component:  T.vc740.js

///////////////////////////////////////////////////////////////////////
//     This menu was designed by Erik Arvidsson for WebFX            //
//                                                                   //
//     For more info and examples see: http://webfx.eae.net          //
//     or send mail to erik@eae.net                                  //
//                                                                   //
//     Feel free to use this code as lomg as this disclaimer is      //
//     intact.                                                       //
///////////////////////////////////////////////////////////////////////
//	12 December 1999 - George James
//		Renamed outerDiv to divOuter to conform to external
//		standards.
//  28 September 2003 - George James
//    Modified toggelMenu() method to invoke menu's click event to cause
//    menu items to be enabled based on context.
//  21 July 2004 - George James
//    Moved invocation of menu's click event to show() method to accommodate
//    sub-menus.

/*
var activeMenu = null;
var activeSub = null;
var tempEl;
var t;

var ie5 = (document.getElementsByTagName != null);

////////////////////////////////////////////////////////
//If you want different colors than default overload these functions...
function menuItemHighlight(el) {
	el.style.background = "highlight";
	el.style.color = "highlighttext";
}

function menuItemNormal(el) {
	el.style.background = "";
	el.style.color = "";
}

function raiseButton(el) {
	el.style.background = "buttonface";
	el.style.color = "buttontext";
	el.style.borderTop ="1 solid buttonhighlight";
	el.style.borderLeft ="1 solid buttonhighlight";
	el.style.borderBottom ="1 solid buttonshadow";
	el.style.borderRight ="1 solid buttonshadow";
	el.style.padding ="1";
	el.style.paddingLeft = "7";
	el.style.paddingRight = "7";
}

function normalButton(el) {
	el.style.background = "buttonface";
	el.style.color = "buttontext";
	el.style.border = "1 solid buttonface";
	el.style.padding ="1";
	el.style.paddingLeft = "7";
	el.style.paddingRight = "7";
}

function pressedButton(el) {
	el.style.background = "buttonface";
	el.style.color = "buttontext";
	el.style.borderTop ="1 solid buttonshadow";
	el.style.paddingTop = "2";
	el.style.borderLeft ="1 solid buttonshadow";
	el.style.paddingLeft = "8";
	el.style.borderBottom ="1 solid buttonhighlight";
	el.style.paddingBottom= "0";
	el.style.borderRight = "1 solid buttonhighlight";
	el.style.paddingRight = "6";
}
//...until here
////////////////////////////////////////////////////////

function cleanUpMenuBar() {
	for (i=0; i <menu.rows.length; i++) {
		for (j=0; j <menu.rows(i).cells.length; j++) {
			if ((menu.rows(i).cells(j).firstChild != null) && (menu.rows(i).cells(j).firstChild.className == "root")) {
				normalButton(menu.rows(i).cells(j).firstChild);
			}
		}
	}
	showWindowedObjects(true);
}

function getMenuItem(el) {
	temp = el;
	while ((temp!=null) && (temp.tagName!="TABLE") && (temp.id!="menubar") && (temp.id!="menu") && (temp.id!="handle")) {
		if ((temp.tagName=="TR") || (temp.className=="root"))
			el = temp;
		temp = temp.parentElement;
	}
	return el;
}

function getSub(el) {
	temp = el;
	while ((temp!=null) && (temp.className != "sub")) {
		if (temp.tagName=="TABLE")
			el = temp;
		temp = temp.parentElement;
	}
	return el;
}

function menuClick() {
	if (event.srcElement == null)
		return;
	var el=getMenuItem(event.srcElement);
	if ((el.className != "disabled") && (el.id != "menubar")){
		if (el.className == "root") {
			if (activeMenu) {
				raiseButton(el);
				showWindowedObjects(true);
			}
			else
				pressedButton(el);
			toggleMenu(el);
		}
		else if (el.HREF) {
			cleanUpMenuBar();
			if (activeMenu)
				toggleMenu(activeMenu.parentElement);
			if (el.target)
				window.open(el.HREF, el.target);
			else if (document.getElementsByTagName("BASE").item(0) != null)
				window.open(el.HREF, document.getElementsByTagName("BASE").item(0).target);
			else
				window.location = el.HREF;
		}
	}
	window.event.cancelBubble = true;
}

////////////////////////////////////////////////////////
// Used to hide the menu when clicked elsewhere
function Restore() {
	if (activeMenu) {
		toggleMenu(activeMenu.parentElement);
	}
	cleanUpMenuBar();
}

document.onclick=Restore;
//window.onblur=Restore; // Wanted to use this to close menus when switching to other app, but it interferes with the way we blur off a re-clicked menubar item

////////////////////////////////////////////////////////

function menuOver() {
        if (divMenu.disabled == true) {return}
	if ((event.fromElement == null) || (event.toElement == null) || (event.fromElement == event.toElement))
		return;
	var fromEl = getMenuItem(event.fromElement);
	var toEl = getMenuItem(event.toElement);
        if (toEl == undefined) {return}
	if (fromEl == toEl)
		return;
	if ((toEl.className != "disabled") && (toEl.id != "menubar")){
		if (toEl.className == "root") {
			if (activeMenu) {
				if (toEl.menu != activeMenu) {
					cleanUpMenuBar();
					toEl.focus();
					toggleMenu(toEl);
				}
			}
			else {
				raiseButton(toEl);
			}
		}
		else {
			if ((fromEl != toEl) && (toEl.tagName != "TABLE")){
				cleanup(toEl.parentElement.parentElement, false);
				toEl.focus();
				if (toEl.className == "sub") {
					showSubMenu(toEl,true);
					menuItemHighlight(toEl);
				}
			}
		}
	}
	event.cancelBubble = true;
}



function menuOut() {
	if ((event.fromElement == null) || (event.toElement == null) || (event.fromElement == event.toElement))
		return;
	var fromEl = getMenuItem(event.fromElement);
	var toEl = getMenuItem(event.toElement);
	if (fromEl == toEl)
		return;
	if (fromEl.className == "root"){
		if (activeMenu) {
			if (fromEl.menu != activeMenu)
				normalButton(fromEl);
		}
		else
			normalButton(fromEl);
	}
	else {
		if  ((fromEl.className != "disabled") && (fromEl.id != "menubar")){
			if ((fromEl.className == "sub") && (getSub(toEl) == fromEl.subMenu) || (fromEl.subMenu == toEl.parentElement.parentElement))
				return;
			else if ((fromEl.className == "sub")){
				cleanup(fromEl.subMenu, true);
				menuItemNormal(fromEl);
			}
			else if ((fromEl != toEl) && (fromEl.tagName != "TABLE"))
				menuItemNormal(fromEl);
			window.status = "";
		}
	}
	event.cancelBubble = true;
}

function menuBarItemAcc(idThis) { // accelerator brings focus to item
	var el=document.getElementById(idThis);
	if (activeMenu) {
		normalButton(activeMenu.parentElement);
	} else {
		cleanUpMenuBar(); // e.g. other option depressed but menu not open, then acc used to go to other
	}
	el.focus();
	toggleMenu(el);
	menuFocusOnFirst(activeMenu);
}

function menuBarItemFocus(el) {
	if (event.srcElement != el) return;

	pressedButton(el);
}

function menuBarItemMouseDown(el) {
	// Ignore mouse-down from child unless it's my own underlined accelerator char
	if ((event.srcElement != el) && ((event.srcElement.tagName != "U") || (event.srcElement.parentElement != el))) return;

	if (el.className != "disabled") {
		var bBlurAfter = false;
		if ((activeMenu) && (activeMenu == el.menu)) {
			bBlurAfter = true;
		}
		toggleMenu(el);
		if (bBlurAfter) {
			raiseButton(el);
			el.blur();  // Take focus off the menu bar item when closed by a click
		}
	}
	event.cancelBubble = true;
	event.returnValue = false;
}

function menuBarItemKeyDown(idThis,idLeft,idRight) {
	var el=document.getElementById(idThis);
	var focusonto = null;
	var bWasOpen = (activeMenu!=null);
	if (event.keyCode==9) { // Tab - eat this to prevent moving to item in tabindex
		event.cancelBubble = true;
	}
	if (event.keyCode==27) { // Escape - close menu, or leave menubar
		if (bWasOpen) {
			toggleMenu(el);
			el.focus();
		} else {
			normalButton(el);
			el.blur();
		}
		event.cancelBubble = true;
	}
	if (event.keyCode==40) { // Down
		if (!bWasOpen) {
			toggleMenu(el);
		}
		menuFocusOnFirst(activeMenu);
		event.cancelBubble = true;
	}
	if (event.keyCode==37) { // Left
		focusonto = document.getElementById(idLeft);
	}
	if (event.keyCode==39) { // Right
		focusonto = document.getElementById(idRight);
	}

	if ((focusonto!=null) && (focusonto!=el)) {
		normalButton(el);
		focusonto.focus();
		if (bWasOpen) {
			toggleMenu(focusonto, true);
			menuFocusOnFirst(activeMenu);
		}
		event.cancelBubble = true;
	}
}

function menuOnItemFocus(el) { // onfocus for menu item
	if (el != event.srcElement)
		return;
	menuItemHighlight(el);
	el.parentElement.parentElement.activeItem = el;
	if (el.HREF)
		window.status = el.HREF;
}

function menuOnItemBlur(el) { // onblur for menu item
	if (el != event.srcElement)
		return;
	var bSetNormal = true;
	if (el.className == "sub") { // Reinstate highlight on submenu parent item
		var ae=document.activeElement;
		var iUp=4;
		while ((ae!=null) && (iUp>0)) {
			iUp=iUp-1;
			ae=ae.parentElement;
		}
		if ((ae!=null) && (ae==el)) {
			bSetNormal = false;
		}
		else if ((activeSub==null) || (activeSub.parentElement.parentElement!=el)) {
			showSubMenu(el, false);
		}
	}
	if (bSetNormal) {
		menuItemNormal(el);
	}
}

function menuKeyDown(parentId) {
	var el = event.srcElement;
	var keyCode = event.keyCode;
	var parentEl = document.getElementById(parentId);
	
	if (!event.altKey && !event.ctrlKey && (((keyCode > 64) && (keyCode < 91)) || ((keyCode > 47) && (keyCode < 58)))) { // A-Z, 0-9 so seek an accelerator
		menuSeekAccessKey(el, keyCode);
		event.cancelBubble = true;
	}
	
	if (keyCode == 13) { // Enter
		el.fireEvent("onclick");
		event.cancelBubble = true;
		event.returnValue=false
	}
	if (keyCode == 38) { // Up
		menuFocusOnPreviousItem(el);
		event.cancelBubble = true;
	}
	if (keyCode == 40) { // Down
		menuFocusOnNextItem(el);
		event.cancelBubble = true;
	}
	if (((keyCode == 37) || (keyCode == 27)) && (parentEl.className == 'sub')) { // Left on submenu
		showSubMenu(parentEl, false);
		parentEl.focus();
		event.cancelBubble = true;
	}
	if ((keyCode == 39) && (el.className == 'sub')) { // Right on item with submenu
		showSubMenu(el, true);
		menuFocusOnFirst(activeSub);
		menuItemHighlight(el);
		event.cancelBubble = true;
	}
}

function menuFocusOnFirst(whichMenu) {
	var el;
	if (whichMenu == null)
		return;
	el = whichMenu.firstChild.firstChild;
	while ((el != null) && (el.className == 'disabled')) el = el.nextSibling;
	if (el != null)
		el.focus();
}

function menuSeekAccessKey(thisEl, keyCode) {
	var el = thisEl.parentElement.firstChild;
	while (el != null) {
		if (getAttr(el,'gjsAccessKey') == keyCode) {
			switch (el.className) {
				case "enabled":
					el.fireEvent("onclick");
					break;
				case "sub":
					showSubMenu(el, true);
					menuFocusOnFirst(activeSub);
					menuItemHighlight(el);
					break;
			}
			el = null;
		}
		else {
			el = el.nextSibling;
		}
	}
}

function menuFocusOnNextItem(thisEl) {
	var el = thisEl;
	do {
		el = el.nextSibling;
		if (el == null)
			el = thisEl.parentElement.firstChild;
	} while ((el.className == 'disabled') && (el != thisEl));
	if (el != thisEl)
		el.focus();
}

function menuFocusOnPreviousItem(thisEl) {
	var el = thisEl;
	do {
		el = el.previousSibling;
		if (el == null)
			el = thisEl.parentElement.lastChild;
	} while ((el.className == 'disabled') && (el != thisEl));
	if (el != thisEl)
		el.focus();
}

function toggleMenu(el, bSkipHide) {
	if (el.menu == null)
		el.menu = getChildren(el);
	if (el.menu == activeMenu) {
		if (activeSub)
			menuItemNormal(activeSub.parentElement.parentElement);
		cleanup(el.menu,true);
		activeMenu = null;
		activeSub = null;
		showWindowedObjects(true);
	}
	else {
		if (activeMenu) {
			cleanup(activeMenu,true);
			hideMenu(activeMenu);
		}
		
		activeMenu = el.menu;

		var tPos = topPos(el.menu) + menu.offsetHeight;

		if ((document.body.offsetHeight - tPos) >= el.menu.offsetHeight) {
			el.menu.style.pixelTop = (ie5) ? el.offsetHeight + 1
										   : menu.offsetHeight - el.offsetTop - 2;
			dir = 2;
		}
		else {
			el.menu.style.pixelTop = (ie5) ? el.offsetTop - el.menu.offsetHeight - 1
										   : el.offsetTop - el.menu.offsetHeight + 2;
			dir = 8;
		}
			
		el.menu.style.pixelLeft = (ie5) ? el.parentElement.offsetLeft - 2 : el.parentElement.offsetLeft;

		show(el.menu, dir);
		if ((typeof(bSkipHide)!="boolean") || !bSkipHide)
			showWindowedObjects(false);
	}
}

function showSubMenu(el,bShow) {
	var dir = 2;
	temp = el;
	list = el.children.tags("TD");
	el = list[list.length-1];
	if (el.menu == null)
		el.menu = getChildren(el);
	temp.subMenu = el.menu;
	if ((el.menu != activeMenu) && (bShow)) {
		activeSub = el.menu;
		var lPos = leftPos(el.menu);
		if ((document.body.offsetWidth - lPos)  >= el.menu.offsetWidth) {
			el.menu.style.left = (ie5) ? el.parentNode.offsetWidth
									   : el.offsetParent.offsetWidth;
			el.menu.style.pixelLeft -= 3;
			dir = 6;
		}
		else {
			el.menu.style.left = - el.menu.offsetWidth + 3;
			el.menu.style.pixelLeft += 3;
			dir = 4;
		}
			

		var tPos = (ie5) ? topPos(el.menu) + el.offsetTop
						 : topPos(el.menu) + el.offsetParent.offsetTop;// + el.menu.offsetTop;

		if ((document.body.offsetHeight - tPos) >= el.menu.offsetHeight)
			el.menu.style.top =  (ie5) ? el.offsetTop - 2
									   : el.offsetParent.offsetTop - 2;
		else
			el.menu.style.top =  (ie5) ? el.offsetTop + el.offsetHeight - el.menu.offsetHeight + 2
									   : el.offsetParent.offsetTop + el.offsetParent.offsetHeight - el.menu.offsetHeight + 2;
		showSub(el.menu, dir);
	}
	else if (!bShow) {
		hideMenu(el.menu);
	}
	else {
		show(el.menu ,dir);
		activeSub = null;
	}
}

function menuPopup(el) {
	if (el.menu == null)
		el.menu = getChildren(el);
	if (activeMenu) {
		cleanup(activeMenu,true);
		hideMenu(activeMenu);
	}
	
	activeMenu = el.menu;
	el.menu.style.pixelTop = event.clientY;
	if (el.menu.style.pixelTop + el.menu.offsetHeight > document.body.clientHeight) el.menu.style.pixelTop -= el.menu.offsetHeight;
	el.menu.style.pixelLeft = event.clientX;
	if (el.menu.style.pixelLeft + el.menu.offsetWidth > document.body.clientWidth) el.menu.style.pixelLeft -= el.menu.offsetWidth;

	show(el.menu, 0);
	//showWindowedObjects(false);
}

////////////////////////////////////////////////////////
//The following two functions are needed to calculate the position
function topPos(el) {
	var temp = el;
	var y = 0;
	while (temp.id!="menu") {
		temp = temp.offsetParent;
		y += temp.offsetTop;
	}
	return y;
}

function leftPos(el) {
	var temp = el;
	var x = 0;
	while (temp.id!="menu") {
		temp = temp.offsetParent;
		x += temp.offsetLeft;
	}
	return x + el.offsetParent.offsetWidth;
}
////////////////////////////////////////////////////////


function show(el, dir) {
  // Before we show a drop down menu, invoke the table's onclick event
	// which will contain code to enabled or disable each items in the menu
	// based on the current state of the application.
	// Pass an event object onto which main properties have been copied
	// so that the event-handler sees the original event (e.g. oncontextmenu)
	var evCopy;
	evCopy=document.createEventObject(event);
	//
	// COMMENTED OUT - Copying all event attributes messes up menu-hide (at least of popmenus) - jm, 6/10/05)
	//for (var evPropName in event) {
	  //try {
	  //  eval("evCopy."+evPropName+"=event."+evPropName)
	  //}
	  //catch(e) {}
	  //finally {}
	//}
    //
	evCopy.offsetX=event.offsetX;
	evCopy.offsetY=event.offsetY;
	el.fireEvent("onclick",evCopy);
		
	// Now make the menu visible visible
	if (typeof(fade) == "function")
		fade(el, true);
	else if (typeof(swipe) == "function") {
		tempElSwipe = el;
		tempDirSwipe = dir;
		el.style.visibility = "visible";
		el.style.visibility = "hidden";
		window.setTimeout("tempSwipe()", 0);
//		swipe(el, dir);
	}
	else
		el.style.visibility = "visible";
}

var tempElSwipe, tempDirSwipe;

function tempSwipe() {
	swipe(tempElSwipe, tempDirSwipe);
}

function showSub(el ,dir) {
	show(el, dir);
//	swipe(el, dir);
//	fade(el, true);
//	el.style.visibility = "visible";
}

function cleanup(menu,hide) {
	if (menu.activeItem) { //If you've been here before
		if ((menu.activeItem.className == "sub") && (menu.activeItem.subMenu)){ //The active item has  a submenu
			cleanup(menu.activeItem.subMenu, true);  //Clean up the subs as well
		}
		menuItemNormal(menu.activeItem);
	}
	if (hide) {
		hideMenu(menu);
	}

}

function hideMenu(el) {
	if (typeof(fade) == "function") {
		fade(el, false);
//		window.setTimeout(fadeTimer);
	}
	else if (typeof(swipe) == "function") {
		hideSwipe(el);
	}
	else
		el.style.visibility = "hidden";
}

function getChildren(el) {
	var tList = el.children.tags("TABLE");
	return tList[0];
}

*/

/////////////////////////////////////////////////////////////////////////////
// The rest is just for the moving/docking
var dragObject = null;
var dragObjectPos = "top";
var tx;
var ty;

/////////////////////////////////////////////////////////////////////////////
// Fixing sizes and positions
// window.onload=fixSize;
// window.onresize=fixSize;

function fixSize() {
	if (dragObjectPos == "top") {
		divOuter.style.top = menu.offsetHeight;
		divOuter.style.height = document.body.clientHeight - menu.offsetHeight;
	}
	else if( dragObjectPos == "bottom") {
		divOuter.style.top = 0;
		divOuter.style.height = document.body.clientHeight - menu.offsetHeight;
		menu.style.top = document.body.clientHeight - menu.offsetHeight;
	}
	else {
		divOuter.style.top = 0;
		divOuter.style.height=document.body.clientHeight;
	}
}
/////////////////////////////////////////////////////////////////////////////
/*
$(function() {
	$(document).on('mousedown', function() {
		if(window.event.srcElement.id == "handle") {
			dragObject = document.all[window.event.srcElement.getAttribute("for")];
			Restore();	//Hide the menus while moving
			ty = (window.event.clientY - dragObject.style.pixelTop);
			window.event.returnValue = false;
			window.event.cancelBubble = true;
		}
		else {
			dragObject = null;
		}
	});
	//
	$(document).on('mouseup', function() {
		if(dragObject) {
			dragObject = null;
		}
	});
	//
	$(document).on('mousemove', function() {
		if(dragObject) {
			if(window.event.clientX >= 0) {
				if((window.event.clientY - ty) <= 15) {
					dragObject.style.border = "0 solid buttonface";
					dragObject.style.width = "100%";
					dragObject.style.top = 0;
					dragObject.style.left = 0;
					dragObjectPos = "top";
					fixSize();
				}
				else if ((window.event.clientY - ty) >= document.body.clientHeight - menu.offsetHeight - 15) {
					dragObject.style.border = "0 solid buttonface";
					dragObject.style.width = "100%";
					dragObject.style.top = document.body.clientHeight - menu.offsetHeight;
					dragObject.style.left = 0;
					dragObjectPos="bottom";
					fixSize();
				}
				else {
					dragObject.style.width = "10px";	
					dragObject.style.left = window.event.clientX;
					dragObject.style.top = window.event.clientY - ty;
					dragObject.style.border = "2px outset white";
					dragObjectPos = "float";
					fixSize();
				}
			}
			else {
				dragObject.style.border = "";
				dragObject.style.left = "0";
				dragObject.style.top = "0";
			}
			window.event.returnValue = false;
			window.event.cancelBubble = true;
		}
	});
});
*/

//This function is used for hiding windowed controls because they interfere with the menus
function showWindowedObjects(show) {
	var windowedObjectTags = new Array("SELECT", "IFRAME", "OBJECT", "APPLET","EMBED");
	var windowedObjects = new Array();
	var j=0;

	for (var i=0; i<windowedObjectTags.length; i++) {
		var tmpTags = document.getElementsByTagName(windowedObjectTags[i]);
		
		if (tmpTags.length > 0) {
			for (var k=0; k<tmpTags.length; k++) {
				windowedObjects[j++] = tmpTags[k];
			}
		}
	}

	for (var i=0; i<windowedObjects.length; i++) {
		if (!show) {
			windowedObjects[i].visBackup = (windowedObjects[i].style.visibility == null) ? "visible" : windowedObjects[i].style.visibility;
			windowedObjects[i].style.visibility = "hidden";
		} else if (typeof(windowedObjects[i].visBackup) == "string") {
			windowedObjects[i].style.visibility = windowedObjects[i].visBackup;
		}
	}
}



